<?php
/**
 * Plugin Name: 内容付费插件
 * Version: 1.4
 * Author: 折雨的天空
 * Author URL: http://www.144d.com
 * Plugin URL: http://www.144d.com
 * Description: 可以设置内容付费，支持Xorpay的支付方式。
 */
if(!defined('EMLOG_ROOT')) {exit('error!');}

if (!class_exists('pay_func', false)) {
    include dirname(__FILE__) . '/pay_func.php';
}

function pay_admin_menu()
{
    echo '<div class="sidebarsubmenu" id="pay_admin"><a href="./plugin.php?plugin=pay">内容付费设置</a></div>';
}
addAction('adm_sidebar_ext', 'pay_admin_menu');

/**
 * 方法名称:pay_blog_setting
 * 说明: 写博客时，展示支付价格
 * @param string $logid
 */
function pay_blog_setting($logid='')
{
    //查询对应日志是否已设置单价
    $paySetting=pay_func::readConfig();
    if (isset($paySetting['pay']) && $paySetting['pay']==1)
    {
        $db=Database::getInstance();
        $sql = "SELECT * FROM " . DB_PREFIX . "pay WHERE bid='".$logid."' limit 1";
        $row = $db->once_fetch_array($sql);
        $row['money']=isset($row['money'])?$row['money']:0;
        $row['desc']=isset($row['desc'])?$row['desc']:'';
        echo '<p>支付单价： <input type="text" name="money" value="'.$row['money'].'"> 元  <input type="button" id="payButton" name="payButton" value="在编辑中插入付费标志"><span class="required">* 先将光标定位于需要付费的内容开始的地方，再点击一次按钮！</span></p>';
        echo '<p><textarea name="payInfo" cols="80" rows="3" style="width: 98%" placeholder="支付说明">'.$row['desc'].'</textarea></p>';
        echo '<script>
			$(document).ready(function(){
				$("#payButton").click(function(){
					editorMap["content"].insertHtml("<p>[#zeyu#]这里替换成需要付费可见的内容[/#zeyu#]</p>");  
				});
			});
		</script>';
    }
}
addAction('adm_writelog_head', 'pay_blog_setting');

/**
 * 方法名称:pay_blog_save
 * 说明: 博客保存时，处理付费信息
 * @param $logid
 */
function pay_blog_save($logid)
{
    if ($logid)
    {
        $paySetting=pay_func::readConfig();
        if (isset($paySetting['pay']) && $paySetting['pay']==1)
        {
            $db=Database::getInstance();
            $data = $db->once_fetch_array("SELECT COUNT(*) AS total FROM " . DB_PREFIX . "pay WHERE `bid`=$logid");
            $pay_money=floatval(pay_func::_post('money'));
            $pay_info=pay_func::_post('payInfo');
            if (isset($data['total']) && $data['total']>0)
            {
                //修改
                $db->query("UPDATE " . DB_PREFIX . "pay SET `money`='$pay_money',`desc`='$pay_info' WHERE `bid`=$logid");
            }
            else
            {
                //新增
                $db->query("INSERT INTO " . DB_PREFIX . "pay (`bid`,`money`,`desc`) VALUES ('".$logid."','".$pay_money."','".$pay_info."')");
            }
        }
    }
}

addAction('save_log','pay_blog_save');

/**
 * 方法名称:pay_blog_view
 * 说明: 博客内容处理
 * @param $logData
 */
function pay_blog_view($logData)
{
    $paySetting=pay_func::readConfig();
    if (isset($paySetting['pay']) && $paySetting['pay']==1)
    {
        $db=Database::getInstance();
        session_start();
        //查询用户是否付费
        $_SESSION['payUserId']=isset($_SESSION['payUserId'])?$_SESSION['payUserId']:'';
        if (!pay_func::isPay($_SESSION['payUserId'],$logData['logid']) && ROLE!='admin')
        {
            if(preg_match('/\[\#zeyu\#\](.*?)\[\/\#zeyu\#\]/is', $logData['log_content'],$res))
            {
                if (isset($res[1]) && $res[1]!='')
                {
                    $content = ob_get_clean();
                    //获取待支付价格及描述
                    $sql = "SELECT * FROM " . DB_PREFIX . "pay WHERE bid='".$logData['logid']."' limit 1";
                    $row = $db->once_fetch_array($sql);
                    $row['money']=isset($row['money'])?$row['money']:0;
                    $row['desc']=isset($row['desc'])?$row['desc']:'';
                    //获取支付人数
                    $data = $db->once_fetch_array("SELECT COUNT(*) AS total FROM " . DB_PREFIX . "pay_log WHERE `bid`= ".$logData['logid']." and status='1'");
                    $payNums=isset($data['total'])?$data['total']:0;
                    if ($row['money']>0)
                    {
                        $html='<div class="paypost">
                    <form id="payPost" onsubmit="return false" action="##" method="post">
                        <div class="feetype"><label for="feetype2"><img id="labe2" src="'.BLOG_URL.'content/plugins/pay/static/images/alipay2.png" nogallery="nogallery" no-zoom="true"><span>支付宝支付</span></label>
                            <input type="radio" id="feetype2" name="feetype" value="alipay" checked="checked">
                        </div>
                        <div class="cl"></div>
                        <span class="pay_price">价格： <b class="bmoney">'.$row['money'].'</b> 元 （已有【 '.$payNums.' 】人付款）</span>
                        <div class="cl"></div>
                        <span class="pay_price pay_email"><input type="text" size="25" name="payEmail" placeholder="您的手机号码或者邮箱"></span>
                        <div class="cl"></div>
                        <input type="hidden" id="userAgent" name="userAgent" value="isDesktop" />
                        <input id="verifybtn" onclick="payBuy(\''.$logData['logid'].'\',\''.BLOG_URL.'?plugin=pay&ac=pay\');" type="button" value="扫码购买" />
                    </form>
                    <div class="cl"></div>
                    <span class="tips">温馨提示：'.$row['desc'].' <br />输入邮箱或者手机号码，付款后可永久阅读隐藏的内容，请勿未经本站许可，擅自分享付费内容。<br />如果您已购买本页内容，输入购买时的手机号码或者邮箱，点击支付，即可查看内容。<br /><b>电子商品，一经购买，不支持退款，特殊原因，请联系客服。</b> </span>
                    <span class="pay_top_left">付费可读</span>
                    <span class="pay_top_right"><img src="'.BLOG_URL.'content/plugins/pay/static/images/icon.png" nogallery="nogallery" no-zoom="true"></span>
                </div>';
                        $content = preg_replace('/\[\#zeyu\#\](.*)\[\/\#zeyu\#\]/uis',$html,$content,-1);
                    }
                    ob_start();
                    echo $content;
                }
            }
        }
        else
        {
            //替换支付标签
            echo pay_func::replaceSign();
            //记录日志
            pay_func::payViewLogs($_SESSION['payUserId'],$logData['logid']);
        }
    }
    else
    {
        //替换支付标签
        echo pay_func::replaceSign();
    }
}
addAction('log_related','pay_blog_view');

/**
 * 方法名称:pay_blog_css
 * 说明:增加样式
 */
function pay_blog_css()
{
    echo '<link href="'.BLOG_URL.'content/plugins/pay/static/css/pay.css?v=1.2" type="text/css" rel="stylesheet" />';
}

addAction('index_head','pay_blog_css');
/**
 * 方法名称:pay_blog_footer
 * 说明: 底部加载JS内容
 */
function pay_blog_footer()
{
    $content = ob_get_clean();
    $content = preg_replace('/\[\#zeyu\#\](.*)\[\/\#zeyu\#\]/Uis','##此部分内容需要付费后，才可查看##',$content);
    ob_start();
    echo $content;
    echo '<script type="text/javascript" src="'.BLOG_URL.'content/plugins/pay/static/js/layer/layer.js"></script>';
    echo '<script type="text/javascript" src="'.BLOG_URL.'content/plugins/pay/static/js/pay.js?v=1.3"></script>';
}
addAction('index_footer','pay_blog_footer');