<?php
/**
 *
 * 文件说明: emlog内容付费插件配置
 *
 * Created by PhpStorm.
 * User: qs9515
 * Date: 2020/3/9
 * Time: 23:32
 *
 * $Id$
 * $LastChangedDate$
 * $LastChangedRevision$
 * $LastChangedBy$
 */
if(!defined('EMLOG_ROOT')) {exit('error!');}

if (!class_exists('pay_func', false)) {
    include dirname(__FILE__) . '/pay_func.php';
}
/**
 * 方法名称:plugin_setting_view
 * 说明:加载配置页面
 */
function plugin_setting_view()
{
    $ac=pay_func::_get('ac');
    if ($ac==''){
        echo pay_func::settingForm(true);
    }
    elseif ($ac=='pay_log'){
        //支付记录
        $page = isset($_GET['page']) ? intval($_GET['page']) : 1;
        $status = isset($_GET['status']) ? intval($_GET['status']) : '1';
        $logNum = pay_func::getPayLogNum($status);
        $logs = pay_func::getPayLogs($page,$status);
        $subPage = '';
        foreach ($_GET as $key=>$val) {
            $subPage .= $key != 'page' ? "&$key=$val" : '';
        }
        $pageurl =  pagination($logNum, Option::get('admin_perpage_num'), $page, "plugin.php?plugin=pay&ac=pay_log&{$subPage}&page=");
        //遍历支付记录
        echo pay_func::payMenus();
        $pageStr='';
        if ($status=='2')
        {
            $pageStr='待';
        }
        echo '<div style="padding-top: 6px;"><b>'.$pageStr.'支付记录</b></div><div class="line"></div>';
        echo '<table width="100%" id="adm_log_list" class="item_list">
  <thead>
      <tr>
        <th width="22"><b><input type="checkbox" name="chkall" id="chkall" value="1" onclick="chkLogs(this)"></b></th>
        <th width="511"><b>支付文章标题</b></th>
        <th width="39" class="tdcenter"><b>用户手机号码/邮箱</b></th>
		<th width="100"><b>付款时间</b></th>
        <th width="146"><b>付款金额</b></th>
        <th width="130"><b>xpay订单号</b></th>
      </tr>
	</thead>
 	<tbody>';
        $totalMoney=0;
        if (!empty($logs) && isset($logs['logs'])){
            $i=1;
            foreach ($logs['logs'] as $k=>$v){
                echo '<tr><td><input type="checkbox" name="ids[]" class="chkall" value="'.$v['plid'].'"></td><td><a href="'.Url::log($v['bid']).'" target="_blank" title="在新窗口查看">'.$logs['blog'][$v['bid']].'</a></td><td>'.$v['phone'].'</td><td>'.$v['pay_time'].'</td><td>'.$v['money'].'</td><td>'.$v['xpay_id'].'</td></tr>';
                $i++;
                $totalMoney+=$v['money'];
            }
        }
        echo '</tbody>';
        echo '</table>';
        echo '<div class="page"><b style="padding-right: 18px;color: orangered;cursor: pointer" onclick="delAll()">删除选中</b>'.$pageurl.' (共有【<b style="color: orangered">'.$logNum.'</b>】条'.$pageStr.'支付记录，共计'.$pageStr.'支付金额【<b style="color: orangered">'.$totalMoney.'</b>】元)</div>';
        echo '<script>function chkLogs(obj) {
          if ($(obj).is(":checked")){
              $(".chkall").attr("checked",true);
          }else {
              $(".chkall").attr("checked",false);
          }
        }
        function delAll() {
          if (confirm("确定要删除选中记录吗？")){
              if ($(".chkall:checked").length){
                  var pageUri = window.location.href;
                  $.ajax({
                    type:"POST",
                    url: "plugin.php?plugin=pay&ac=pay_delete_logs",
                    dataType:"json",
                    data:$(".chkall:checked").serialize(),
                    success:function(data) {
                        alert(data.msg);
                        window.location=pageUri;
                    },
                    error:function(){
                        alert("删除选中数据发生错误！");
                        return false;
                    }
                })
              }else{
                  alert("未选中任何记录！");
              }
          }
        }
        </script>';
    }
    elseif ($ac=='pay_statistics'){
        //支付统计
        echo pay_func::payMenus();
        //输出已支付总金额，未支付总金额，已支付订单数量，未支付订单数量，平均价格
        $payData=pay_func::statisTotal();
        echo '<div><b>支付概览</b></div><div class="line"></div>';
        echo '<table style="width: 100%" class="statistics" cellpadding="0" cellspacing="0">';
        echo '<tr><th colspan="3">已支付信息</th><th colspan="3">未支付信息</th></tr>';
        echo '<tr><th>订单数</th><th>总金额</th><th>平均价格</th><th>订单数</th><th>总金额</th><th>平均价格</th></tr>';
        if (!empty($payData)){
            echo '<tr><td>'.$payData[1]['nums'].'</td><td>'.$payData[1]['money'].'</td><td>'.$payData[1]['avgg'].'</td><td>'.$payData[2]['nums'].'</td><td>'.$payData[2]['money'].'</td><td>'.$payData[2]['avgg'].'</td></tr>';
        }
        echo '</table>';
        //输出已支付统计概览、本日、本月、本年
        echo '<div style="padding-top: 6px"><b>年内支付情况</b></div><div class="line"></div>';
        echo '<table style="width: 100%" class="statistics" cellpadding="0" cellspacing="0">';
        echo '<tr><th colspan="2">今日</th><th colspan="2">本月</th><th colspan="2">今年</th></tr>';
        echo '<tr><th>订单数</th><th>总金额</th><th>订单数</th><th>总金额</th><th>订单数</th><th>总金额</th></tr>';
        //本日
        $payDataDay=pay_func::statisByMonth('%Y-%m-%d');
        //本月
        $payDataMonth=pay_func::statisByMonth('%Y-%m');
        //本年
        $payDataYear=pay_func::statisByMonth('%Y');
        echo '<tr><td>'.(isset($payDataDay['nums'])?$payDataDay['nums']:0).'</td><td>'.(isset($payDataDay['money'])?$payDataDay['money']:0).'</td><td>'.(isset($payDataMonth['nums'])?$payDataMonth['nums']:0).'</td><td>'.(isset($payDataMonth['money'])?$payDataMonth['money']:0).'</td><td>'.(isset($payDataYear['nums'])?$payDataYear['nums']:0).'</td><td>'.(isset($payDataYear['money'])?$payDataYear['money']:0).'</td></tr>';
        echo '</table>';
        //输出近6个月已支付的金额/博客总数
        echo '<div style="padding-top: 6px"><b>近6个月支付情况</b></div><div class="line"></div>';
        echo '<table style="width: 100%" class="statistics" cellpadding="0" cellspacing="0">';
        $payDataByMonth=pay_func::statisEveryMonth(6);
        if (!empty($payDataByMonth)){
            echo '<tr>';
            foreach ($payDataByMonth as $k=>$v){
                echo '<th colspan="2">'.$k.'</th>';
            }
            echo '</tr>';
        }
        if (!empty($payDataByMonth)){
            echo '<tr>';
            foreach ($payDataByMonth as $k=>$v){
                echo '<th>订单数</th><th>金额</th>';
            }
            echo '</tr>';
            echo '<tr>';
            foreach ($payDataByMonth as $k=>$v){
                echo '<td>'.$v['nums'].'</td><td>'.$v['money'].'</td>';
            }
            echo '</tr>';
        }
        echo '</table>';
        echo '<style>
.statistics th,tr,td{line-height: 26px;border:1px solid #2C2C2C;text-align: center}
.statistics th{background-color: #398ade;color: #ffffff;}
</style>';
    }
    elseif ($ac=='pay_top'){
        //输出支付次数排名前10的博客记录
        echo pay_func::payMenus();
        $pagLogsTop=pay_func::statisTop(10);
        echo '<div style="padding-top: 6px;"><b>支付排行</b></div><div class="line"></div>';
        echo '<table width="100%" class="item_list" style="text-align: left;line-height: 18px">
  <thead>
      <tr>
        <th width="511"><b>支付文章标题</b></th>
        <th width="59" class="tdcenter"><b>支付次数</b></th>
      </tr>
	</thead>
 	<tbody>';
        if (!empty($pagLogsTop) && isset($pagLogsTop['logs'])){
            $i=1;
            foreach ($pagLogsTop['logs'] as $k=>$v){
                echo '<tr><td><a href="'.Url::log($v['bid']).'" target="_blank" title="在新窗口查看">'.$pagLogsTop['blog'][$v['bid']].'</a></td><td>'.$v['nums'].'</td></tr>';
            }
        }
        echo '</tbody>';
        echo '</table>';
    }
    elseif ($ac=='pay_delete_logs'){
        ob_clean();
        $data['status']=0;
        $data['msg']="删除选中数据失败！";
        //删除支付记录
        if (is_array($_POST['ids']) && !empty($_POST['ids'])){
            if (pay_func::deleteLogs($_POST['ids'])){
                $data['status']=1;
                $data['msg']="删除选中支付记录成功，本次删除记录【".count($_POST['ids'])."】条！";
            }
        }
        echo json_encode($data,JSON_UNESCAPED_UNICODE);
        exit;
    }
    else{
        echo pay_func::settingForm(true);
    }
}

/**
 * 方法名称:plugin_setting
 * 说明:保存配置信息
 */
function plugin_setting()
{
    $pay_setting=isset($_POST['data'])?$_POST['data']:'';
    if (!empty($pay_setting))
    {
        if (isset($pay_setting['pay']) && $pay_setting['pay']=='1')
        {
            if (isset($pay_setting['aid']) && isset($pay_setting['secret']))
            {
                if ($pay_setting['aid']=='')
                {
                    emMsg('开启支付时，AID必须填写！', BLOG_URL . 'admin/plugin.php?plugin=pay');
                }
                if ($pay_setting['secret']=='')
                {
                    emMsg('开启支付时，app secret必须填写！', BLOG_URL . 'admin/plugin.php?plugin=pay');
                }
                foreach ($pay_setting as $k=>$v)
                {
                    $pay_setting[$k]=htmlspecialchars($v);
                }
                $fileContent="<?php\n";
                $fileContent.="/** 内容支付插件配置信息\n";
                $fileContent.="* Author:折雨的天空\n";
                $fileContent.="* URL: http://www.144d.com\n";
                $fileContent.="* Time: ".date('Y-m-d H:i:s')."\n";
                $fileContent.="*/\n";
                $fileContent.="if(!defined('EMLOG_ROOT')) {exit('error!');}\n";
                $fileContent.= "\$paySetting=".var_export($pay_setting,true).";";
                file_put_contents(dirname(__FILE__).'/pay_config.php',$fileContent);
            }
            else
            {
                emMsg('开启支付时，AID和app secret必须填写！', BLOG_URL . 'admin/plugin.php?plugin=pay');
            }
        }
        else
        {
            foreach ($pay_setting as $k=>$v)
            {
                $pay_setting[$k]=htmlspecialchars($v);
            }
            $fileContent="<?php\n";
            $fileContent.="/** 内容支付插件配置信息\n";
            $fileContent.="* Author:折雨的天空\n";
            $fileContent.="* URL: http://www.144d.com\n";
            $fileContent.="* Time: ".date('Y-m-d H:i:s')."\n";
            $fileContent.="*/\n";
            $fileContent.="if(!defined('EMLOG_ROOT')) {exit('error!');}\n";
            $fileContent.= "\$paySetting=".var_export($pay_setting,true).";";
            file_put_contents(dirname(__FILE__).'/pay_config.php',$fileContent);
        }
    }
    else
    {
        emMsg('数据保存失败！', BLOG_URL . 'admin/plugin.php?plugin=pay');
    }
}